"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = install;
exports.npmUpgrade = npmUpgrade;
exports.getCommand = getCommand;

require("core-js/modules/es.promise.js");

var _execa = _interopRequireDefault(require("execa"));

var _mapSeriesAsync = _interopRequireDefault(require("map-series-async"));

var _which = _interopRequireDefault(require("which"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function install(_x) {
  return _install.apply(this, arguments);
}

function _install() {
  _install = _asyncToGenerator(function* (yo) {
    yield (0, _execa.default)('git', ['init'], {
      cwd: yo.destinationPath('')
    });
    yield (0, _execa.default)('git', ['add', '.'], {
      cwd: yo.destinationPath('')
    });
    return npmUpgrade(yo, (yield getCommand()) || 'npm');
  });
  return _install.apply(this, arguments);
}

function npmUpgrade(_x2) {
  return _npmUpgrade.apply(this, arguments);
}

function _npmUpgrade() {
  _npmUpgrade = _asyncToGenerator(function* (yo, npm = 'npm') {
    yield (0, _execa.default)(npm, ['upgrade', '--latest'], {
      cwd: yo.destinationPath(''),
      stdio: 'inherit'
    });
  });
  return _npmUpgrade.apply(this, arguments);
}

function getCommand() {
  return _getCommand.apply(this, arguments);
}

function _getCommand() {
  _getCommand = _asyncToGenerator(function* (commands = ['pnpm', 'yarn', 'npm']) {
    let result = null;
    yield (0, _mapSeriesAsync.default)(commands, /*#__PURE__*/function () {
      var _ref = _asyncToGenerator(function* (command) {
        if (!result && (yield (0, _which.default)(command))) result = command;
      });

      return function (_x3) {
        return _ref.apply(this, arguments);
      };
    }());
    return result;
  });
  return _getCommand.apply(this, arguments);
}