"use strict";

require("core-js/modules/es.array.filter.js");

require("core-js/modules/es.object.get-own-property-descriptors.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = prompting;

require("core-js/modules/es.promise.js");

require("core-js/modules/es.symbol.description.js");

var _yoBasePrompts = _interopRequireDefault(require("yo-base-prompts"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function prompting(_x) {
  return _prompting.apply(this, arguments);
}

function _prompting() {
  _prompting = _asyncToGenerator(function* (yo) {
    const yoBasePrompts = new _yoBasePrompts.default(yo);

    const _yield$yoBasePrompts$ = yield yoBasePrompts.prompt({
      authorEmail: true,
      authorName: true,
      authorUrl: true,
      description: true,
      destination: true,
      githubUsername: true,
      homepage: true,
      license: true,
      name: true,
      repository: true,
      version: true
    }),
          authorEmail = _yield$yoBasePrompts$.authorEmail,
          authorName = _yield$yoBasePrompts$.authorName,
          authorUrl = _yield$yoBasePrompts$.authorUrl,
          description = _yield$yoBasePrompts$.description,
          destination = _yield$yoBasePrompts$.destination,
          githubUsername = _yield$yoBasePrompts$.githubUsername,
          homepage = _yield$yoBasePrompts$.homepage,
          license = _yield$yoBasePrompts$.license,
          name = _yield$yoBasePrompts$.name,
          repository = _yield$yoBasePrompts$.repository,
          version = _yield$yoBasePrompts$.version;

    const keywords = [name];

    for (;;) {
      const _yield$yo$prompt = yield yo.prompt([{
        type: 'input',
        name: 'keyword',
        message: 'Keyword:'
      }]),
            keyword = _yield$yo$prompt.keyword;

      if (keyword === '') break;
      keywords.push(keyword);
    }

    const _yield$yo$optionOrPro = yield yo.optionOrPrompt([{
      type: 'confirm',
      name: 'bin',
      message: 'Project is a bin',
      default: false
    }, {
      type: 'confirm',
      name: 'lock',
      message: 'Support package-lock.json',
      default: false
    }]),
          bin = _yield$yo$optionOrPro.bin,
          lock = _yield$yo$optionOrPro.lock;

    yo.answers = {
      authorEmail,
      authorName,
      authorUrl,
      bin,
      lock,
      description,
      destination,
      githubUsername,
      homepage,
      keywords,
      license,
      name,
      repository,
      version
    };

    if ((yield yo.optionOrPrompt([{
      type: 'confirm',
      name: 'generatorGithubProject',
      message: 'Generator GitHub Project:',
      default: true
    }])).generatorGithubProject) {
      yo.composeWith(require.resolve('generator-github-project'), _objectSpread(_objectSpread({}, yo.answers), {}, {
        template: 'minimal'
      }));
    }

    yo.context = _objectSpread(_objectSpread({}, yo.context), yo.answers);
  });
  return _prompting.apply(this, arguments);
}